#execute as @e[tag=Cannon1] store result score @s scm_rx run data get entity @s Rotation[0]
#execute as @e[tag=Cannon1,nbt=!{HandItems:[]}] run scoreboard players add @s scm_rx 1
#execute as @e[tag=Cannon1] store result entity @s Rotation[0] float 1 run scoreboard players get @s scm_rx
#execute as @e[tag=Cannon1] run data modify entity @s HandItems set value []
#炮弹轨迹
execute at @e[tag=scm_cannonball] run particle campfire_cosy_smoke ~ ~ ~ 0 0 0 0 1 force
execute at @e[tag=scm_cannonball] run particle flame ~ ~ ~ 0.1 0.1 0.1 0 5 force
execute at @e[tag=scm_cannonball] run particle poof ~ ~ ~ 0.1 0.1 0.1 0.1 3 force
#炮弹爆炸
execute as @e[tag=scm_cannonball,nbt={inGround:1b}] run function scm:cannon/cannon_explode

#装填
execute as @e[tag=Cannon1,scores={scm_Maxammo=..3},nbt={HandItems:[{id:"minecraft:firework_star"},{}]}] at @s run function scm:cannon/cannon_load

#退弹
execute as @e[tag=Cannon1,scores={scm_Maxammo=..3},nbt={HandItems:[{id:"minecraft:stick"},{}]}] at @s run function scm:cannon/cannon_unload

#发射
execute as @e[tag=Cannon1,scores={scm_ammo1=1..},nbt={HandItems:[{id:"minecraft:redstone_torch"},{}]}] at @s run function scm:cannon/cannon_fire
execute as @e[tag=Cannon1,scores={scm_ammo1=0},nbt={HandItems:[{id:"minecraft:redstone_torch"},{}]}] at @s run give @p[gamemode=!creative,gamemode=!spectator,distance=0..7] redstone_torch
execute as @e[tag=Cannon1,scores={scm_ammo1=0},nbt={HandItems:[{id:"minecraft:redstone_torch"},{}]}] run item replace entity @s weapon with air

#状态记录
execute as @e[tag=Cannon1] run execute store result score @s scm_rx run data get entity @s Rotation[0]
execute as @e[tag=Cannon1] run execute store result score @s scm_ry run data get entity @s Rotation[1]

#放置火炮
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025005},Count:1b}}] at @s unless entity @e[tag=scm_cannon,distance=0..3.2] unless block ~ ~-1 ~ air unless entity @e[type=item,nbt={Item:{tag:{spanner:1b}}},distance=0..1.5] unless entity @e[type=armor_stand,distance=0..1.5] run scoreboard players add @s scm_time 1
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025005},Count:1b}},scores={scm_time=1..}] at @s unless entity @e[tag=scm_cannon,distance=0..3.2] run function scm:basic/set_pos
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025005},Count:1b}},scores={scm_time=61..}] at @s run function scm:cannon/cannon_set

#拆除火炮
execute as @e[tag=Cannon1] at @s if entity @e[type=item,nbt={Item:{tag:{spanner:1b}}},distance=0..1.4] run loot spawn ~ ~1.5 ~ loot scm:cannon
execute as @e[tag=Cannon1] at @s if entity @e[type=item,nbt={Item:{tag:{spanner:1b}}},distance=0..1.4] run kill @s
execute as @e[tag=Cannon] at @s unless entity @e[tag=Cannon1,distance=0..1] run playsound item.armor.equip_netherite player @a ~ ~ ~ 1 1.6
execute as @e[tag=Cannon] at @s unless entity @e[tag=Cannon1,distance=0..1] run kill @s

#火炮旋转方向切换 1水平顺时针2水平逆时针3上4下
execute as @e[tag=Cannon1,nbt={HandItems:[{tag:{spanner:1b}}]}] run scoreboard players add @s scm_spin 1
execute as @e[tag=Cannon1,nbt={HandItems:[{tag:{spanner:1b}}]}] run loot give @p[gamemode=!creative,gamemode=!spectator,distance=0..7] loot scm:spanner
execute as @e[tag=Cannon1,nbt={HandItems:[{tag:{spanner:1b}}]}] run item replace entity @s weapon with air
scoreboard players set @e[tag=Cannon1,scores={scm_spin=5..}] scm_spin 1

#火炮旋转
scoreboard players add @e[tag=Cannon1,tag=2] scm_rx 1
scoreboard players remove @e[tag=Cannon1,tag=!2,tag=3] scm_rx 1
tag @e[tag=Cannon1,tag=!2,tag=3] remove 3
tag @e[tag=Cannon1,tag=2] remove 2
execute as @a[scores={scm_control=1..}] at @s run scoreboard players add @e[tag=Cannon1,scores={scm_spin=1},distance=0..3] scm_rx 1
execute as @a[scores={scm_control=1..}] at @s run scoreboard players remove @e[tag=Cannon1,scores={scm_spin=2},distance=0..3] scm_rx 1
execute as @a[scores={scm_control=1..}] at @s run scoreboard players remove @e[tag=Cannon1,scores={scm_spin=3},distance=0..3] scm_ry 1
execute as @a[scores={scm_control=1..}] at @s run scoreboard players remove @e[tag=Cannon1,scores={scm_spin=3,scm_ry=0},distance=0..3] scm_ry 1
execute as @a[scores={scm_control=1..}] at @s run scoreboard players add @e[tag=Cannon1,scores={scm_spin=4},distance=0..3] scm_ry 1
execute as @a[scores={scm_control=1..}] at @s run scoreboard players add @e[tag=Cannon1,scores={scm_spin=4,scm_ry=0},distance=0..3] scm_ry 1
execute as @a[scores={scm_control=1}] at @s run execute at @e[tag=scm_cannon,distance=0..3] run playsound minecraft:ui.stonecutter.take_result block @a ~ ~ ~ 1

#竖直方向角度限制
execute as @e[tag=Cannon1,scores={scm_ry=16..}] run scoreboard players set @s scm_ry 15
execute as @e[tag=Cannon1,scores={scm_ry=..-61}] run scoreboard players set @s scm_ry -60

#方向设置
execute as @e[tag=Cannon1] store result entity @s Rotation[0] float 1 run scoreboard players get @s scm_rx
execute as @e[tag=Cannon1] store result entity @s Rotation[1] float 1 run scoreboard players get @s scm_ry

#跟随
execute as @e[tag=Cannon] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=Cannon1,sort=nearest,limit=1,distance=0..2] Rotation[0]
execute as @e[tag=Cannon] at @s run execute store result entity @s Rotation[1] float 1 run data get entity @e[tag=Cannon1,sort=nearest,limit=1,distance=0..2] Rotation[1]
execute as @e[tag=Cannon] at @s run execute store result entity @s Pose.Head[0] float 1 run data get entity @e[tag=Cannon1,sort=nearest,limit=1,distance=0..2] Rotation[1]