#发射检定-火焰喷射器
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:5}}}] run tag @s add scm_fire5
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:5,Fuel:0}}}] run tag @s remove scm_fire5
execute as @a[tag=scm_fire5] run function scm:fire/flamethrower_fire


#检测子弹数量
execute as @a[gamemode=!creative] store result score @s scm_cartrigde run clear @s iron_nugget{Tags:["scm_cartridge"]} 0
scoreboard players set @a[gamemode=creative,scores={scm_cartrigde=..1}] scm_cartrigde 1
execute as @a[gamemode=creative,scores={scm_cartrigde=2..}] store result score @s scm_cartrigde run clear @s iron_nugget{Tags:["scm_cartridge"]} 0
advancement grant @a[scores={scm_cartrigde=1728..}] only scm:slime_musket/transporter

#水中无法开枪
execute as @a at @s anchored eyes if block ~ ~ ~ water run scoreboard players set @s scm_shoot 0
execute as @a at @s anchored eyes if block ~ ~ ~ water_cauldron run scoreboard players set @s scm_shoot 0

#着火时走火
execute as @a store result score @s scm_firetime run data get entity @s Fire
scoreboard players add @a[scores={scm_firetime=1..},nbt={SelectedItem:{tag:{load:1}}}] scm_firetime1 1
execute as @a[scores={scm_firetime1=20..},nbt={SelectedItem:{tag:{load:1}}}] run function scm:discharge

#shift检定-装填
tag @a remove scm_reloading
tag @a[scores={scm_reload=1..,scm_cartrigde=1..},nbt={SelectedItem:{tag:{load:0}}}] add scm_reloading
scoreboard players set @a[scores={scm_cooldown=1..}] scm_reload 0
#弹筒发射器
execute as @a[tag=scm_reloading,nbt={SelectedItem:{tag:{MusketType:6}}}] run tag @s[nbt=!{Inventory:[{Slot:-106b,tag:{Pots:2}}]}] remove scm_reloading
tag @a[scores={scm_reload=1..},nbt={SelectedItem:{tag:{load:0}},Inventory:[{Slot:-106b,tag:{Pots:2}}]}] add scm_reloading
#火焰喷射器
execute as @a[tag=scm_reloading,nbt={SelectedItem:{tag:{MusketType:5}}}] run tag @s[nbt=!{Inventory:[{Slot:-106b,tag:{Pots:1}}]}] remove scm_reloading
tag @a[scores={scm_reload=1..},nbt={SelectedItem:{tag:{load:0}},Inventory:[{Slot:-106b,tag:{Pots:1}}]}] add scm_reloading

execute as @a[scores={scm_reload=1..},nbt={SelectedItem:{tag:{MusketType:5,load:1,Fuel:0}}}] at @s run function scm:specialgun/load1_flamethrower
execute as @a[scores={scm_reload=1..},nbt={SelectedItem:{tag:{Pots:0}},Inventory:[{Slot:-106b,id:"minecraft:blaze_powder"}]}] run function scm:specialgun/fuel

scoreboard players set @a[tag=!scm_reloading] scm_reload 0

scoreboard players set @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{AmmoGun:1}}}] scm_reload 0
execute at @a[scores={scm_reload=1},nbt=!{SelectedItem:{tag:{MusketType:4}}}] run playsound item.armor.equip_chain player @a ~ ~ ~ 1.2 0.4
scoreboard players add @a[scores={scm_reload=1}] scm_reload 1


#清除
tag @a[nbt={SelectedItem:{tag:{load:1}}}] add scm_shootable
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}},scores={scm_cooldown=0}] as @s[nbt=!{SelectedItem:{tag:{ammo:0}}}] run tag @s add scm_shootable
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}},scores={scm_cooldown=0}] as @s[nbt=!{SelectedItem:{tag:{Fuel:0}}}] run tag @s add scm_shootable
scoreboard players set @a[tag=!scm_shootable] scm_shoot 0
tag @a remove scm_shootable

#发射冷却
scoreboard players remove @a[scores={scm_cooldown=1..}] scm_cooldown 1
scoreboard players add @a[scores={scm_cooldown=..-1}] scm_cooldown 1

#发射检定-手枪
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:1,load:1}}}] run tag @s add scm_fire1
execute as @a[tag=scm_fire1] run function scm:fire/pistol_fire

#发射检定-步枪
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:2,load:1}}}] run tag @s add scm_fire2
execute as @a[tag=scm_fire2] run function scm:fire/musket_fire

#发射检定-霰弹枪
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:3,load:1}}}] run tag @s add scm_fire3
execute as @a[tag=scm_fire3] run function scm:fire/shotgun_fire

#发射检定-转轮手枪
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:4}}}] run tag @s add scm_fire4
execute as @a[tag=scm_fire4] run function scm:fire/revolver_fire

#发射检定-弹筒抛射器
execute as @a[scores={scm_shoot=1..},nbt={SelectedItem:{tag:{MusketType:6}}}] run tag @s add scm_fire6
execute as @a[tag=scm_fire6] run function scm:fire/launcher_fire

#shift检定-刺刀
tag @a remove scm_bayonet
tag @a[scores={scm_bayonet=1..},nbt={SelectedItem:{tag:{MusketType:2,bayonet:0}},Inventory:[{Slot:-106b,id:"minecraft:iron_sword",Count:1b}]}] add scm_bayonet
tag @a[scores={scm_bayonet=1..},nbt={Inventory:[{Slot:-106b,tag:{MusketType:2,bayonet:1}}]}] add scm_bayonet
scoreboard players set @a[tag=!scm_bayonet] scm_bayonet 0
execute at @a[scores={scm_bayonet=1}] run playsound item.armor.equip_chain player @a ~ ~ ~ 1.2 0.4
scoreboard players add @a[scores={scm_bayonet=1}] scm_bayonet 1

#上刺刀
execute as @a[scores={scm_bayonet=30..},nbt={SelectedItem:{tag:{MusketType:2,bayonet:0}},Inventory:[{Slot:-106b,id:"minecraft:iron_sword",Count:1b}]}] at @s run function scm:basic/bayonet

#下刺刀
execute as @a[scores={scm_bayonet=30..},nbt={Inventory:[{Slot:-106b,tag:{MusketType:2,bayonet:1}}]}] at @s run function scm:basic/debayonet

#手枪装填
execute as @a[scores={scm_reload=25..},nbt={SelectedItem:{tag:{MusketType:1}}}] at @s run function scm:basic/reload

#步枪装填
execute as @a[scores={scm_reload=36..},nbt={SelectedItem:{tag:{MusketType:2}}}] at @s run function scm:basic/reload

#霰弹枪装填
execute as @a[scores={scm_reload=32..},nbt={SelectedItem:{tag:{MusketType:3}}}] at @s run function scm:basic/reload

#转轮手枪装填
execute as @a[scores={scm_reload=12..},nbt={SelectedItem:{tag:{MusketType:4}}}] at @s run function scm:basic/reload_ammo

#火焰喷射器装填
execute as @a[scores={scm_reload=42..},nbt={SelectedItem:{tag:{MusketType:5}}}] at @s run function scm:specialgun/load_flamethrower

#弹筒抛射器装填
execute as @a[scores={scm_reload=42..},nbt={SelectedItem:{tag:{MusketType:6}}}] at @s run function scm:specialgun/load_launcher


#子弹轨迹
execute at @e[tag=scm_bullet] run particle smoke ~ ~ ~ 0.1 0.1 0.1 0 1 force

#清除子弹
scoreboard players add @e[tag=scm_bullet] scm_time 1
kill @e[tag=scm_shotgunbullet,scores={scm_time=5..}]
execute as @e[tag=scm_bullet,nbt={inGround:1b}] run function scm:basic/bulletclear

#更新手册
scoreboard players enable @a scm_book
scoreboard players enable @a scm_guide
execute as @a[scores={scm_book=1..}] run function scm:basic/book
execute as @a[scores={scm_guide=1..}] run function scm:basic/guide
scoreboard players set @a scm_book 0
scoreboard players set @a scm_guide 0

#子弹数量显示
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}}] store result score @s scm_ammodisplay run data get entity @s SelectedItem.tag.ammo
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}}] store result score @s scm_ammodisplay run data get entity @s SelectedItem.tag.Fuel
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}}] run title @s actionbar [{"translate":"item.slime_musket.ammodisplay"},{"score":{"objective":"scm_ammodisplay","name":"@s"}}]
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}}] run title @s actionbar [{"translate":"item.slime_musket.ammodisplay"},{"score":{"objective":"scm_ammodisplay","name":"@s"}}]

#火焰
execute as @e[tag=scm_flame] at @s run function scm:fire/flame
#弹筒
execute as @e[tag=scm_pot] at @s run function scm:fire/pot
#扳手/显示器
scoreboard players set @a[scores={scm_control1=0}] scm_control 0
scoreboard players set @a[nbt=!{SelectedItem:{tag:{spanner:1b}}},nbt=!{SelectedItem:{tag:{displayer:1b}}}] scm_control 0
scoreboard players set @a[scores={scm_control=11..}] scm_control 1
scoreboard players set @a scm_control1 0
#地雷放置
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025019},Count:1b}}] at @s unless entity @e[tag=mine,distance=0..1.2] unless block ~ ~-1 ~ air run scoreboard players add @s scm_time 1
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025019},Count:1b}},scores={scm_time=60}] at @s run function scm:basic/set_pos
execute as @e[type=item,nbt={Item:{id:"minecraft:firework_star",tag:{CustomModelData:1025019},Count:1b}},scores={scm_time=61..}] at @s run function scm:basic/mine
#地雷特效
scoreboard players add @e[tag=mine] scm_time 1
execute as @e[tag=mine,scores={scm_time=60}] at @s positioned ~ ~1 ~ run particle smoke ~ ~ ~
scoreboard players set @e[tag=mine,scores={scm_time=161..}] scm_time 1
#地雷拆除
execute as @e[tag=mine] at @s if block ~ ~ ~ air run loot spawn ~ ~0.5 ~ loot scm:mine
execute as @e[tag=mine] at @s if block ~ ~ ~ air run kill @s
#地雷爆炸
execute as @e[tag=mine] at @s positioned ~ ~1 ~ if entity @e[type=!item,tag=!scm_mine,type=!snowball,type=!item_frame,type=!glow_item_frame,distance=0..1] run summon creeper ~ ~ ~ {Fuse:0,ignited:1b,ExplosionRadius:3}
execute as @e[tag=mine] at @s positioned ~ ~1 ~ if entity @e[type=fishing_bobber,distance=0..1] run advancement grant @p only scm:slime_musket/anti-mine
execute as @e[tag=mine] at @s positioned ~ ~1 ~ if entity @e[type=!item,tag=!scm_mine,type=!snowball,type=!item_frame,type=!glow_item_frame,distance=0..1] run kill @s