#storager
#execute as @a[nbt={SelectedItem:{tag:{storager:1b}}}] run function scm:machine/common/storager/display
#scoreboard players set @a[nbt=!{SelectedItem:{tag:{storager:1b}}}] scm_time1 0
execute as @e[type=item,nbt={Item:{tag:{storager:1b}}}] at @s run function scm:machine/common/storager/safe

#conveyor_belt
#物品判定
execute as @e[type=armor_stand,tag=belt] at @s run function scm:machine/common/belt/check
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/check0
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/check1
#运动
execute as @e[type=item,tag=belt] at @s run function scm:machine/common/belt/move

#mech_bit
execute as @e[tag=scm_mech_bit] at @s run function scm:machine/common/mech_bit/check
execute as @e[tag=scm_mech_bit,tag=!scm_stop] at @s if block ^ ^1.5 ^1 end_portal_frame run advancement grant @p only scm:slime_craft/flight_of_fancy
execute as @e[tag=scm_mech_bit,tag=!scm_stop] at @s positioned ^ ^1.5 ^ unless block ^ ^ ^1 #scm:mech_saw unless block ^ ^ ^1 #scm:mech_pump unless block ^ ^ ^1 #scm:none run tag @s add scm_1
execute as @e[tag=scm_mech_bit,tag=!scm_1] run function scm:machine/common/mech_bit/stop
execute as @e[tag=scm_mech_bit,tag=scm_1] at @s run function scm:machine/common/mech_bit/dig

#storehouse
#检查
execute as @e[tag=scm_storehouse1,tag=scm_stock_upgrade,nbt={HandItems:[{tag:{storager:1b,stockUpgrade:1}}]}] at @s positioned ^ ^0.5 ^-0.32 if entity @e[tag=scm_storehouse,tag=scm_empty,distance=..0.3,sort=nearest,limit=1] run function scm:machine/common/storager/get
execute as @e[tag=scm_storehouse1,tag=!scm_stock_upgrade,nbt={HandItems:[{tag:{storager:1b}}]},nbt=!{HandItems:[{tag:{stockUpgrade:1}}]}] at @s positioned ^ ^0.5 ^-0.32 if entity @e[tag=scm_storehouse,tag=scm_empty,distance=..0.3,sort=nearest,limit=1] run function scm:machine/common/storager/get

execute as @e[tag=scm_storehouse1,nbt={HandItems:[{tag:{upgrade:1}}]}] at @s run function scm:machine/common/storehouse/upgrade
execute as @e[tag=scm_storehouse1,nbt={HandItems:[{tag:{spanner:1b}}]}] at @s positioned ^ ^0.5 ^-0.32 run execute as @e[tag=scm_storehouse,distance=..0.3,sort=nearest,limit=1] at @s run function scm:machine/common/storehouse/change_export
execute as @e[tag=scm_storehouse1] at @s positioned ^ ^1.5 ^0.68 run function scm:machine/common/storehouse/pre_store

execute as @e[tag=scm_storehouse] at @s run function scm:machine/common/storehouse/check
#初次存储
execute as @e[tag=storehouse_north,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_east,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_south,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
execute as @e[tag=storehouse_west,tag=scm_empty] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store_first
#存储
execute as @e[tag=storehouse_north,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store
execute as @e[tag=storehouse_east,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store
execute as @e[tag=storehouse_south,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store
execute as @e[tag=storehouse_west,tag=!scm_empty,tag=!stop_store] at @s positioned ^ ^1 ^1 if entity @e[type=item,distance=..0.5,nbt=!{Item:{tag:{cannotstore:1b}}}] run function scm:machine/common/storehouse/store
#输出
execute as @e[tag=storehouse_north,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_east,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_south,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
execute as @e[tag=storehouse_west,tag=!scm_empty,tag=!scm_stop] at @s positioned ^ ^1 ^-1 unless entity @e[type=item,distance=..0.5] run function scm:machine/common/storehouse/export
#红石比较器
execute as @e[tag=!storehouse_north,tag=!storehouse_south,tag=scm_storehouse] at @s if block ~ ~1 ~1 comparator[facing=north,mode=compare] run function scm:machine/common/storehouse/comparator_x_north
execute as @e[tag=!storehouse_north,tag=!storehouse_south,tag=scm_storehouse] at @s if block ~ ~1 ~-1 comparator[facing=south,mode=compare] run function scm:machine/common/storehouse/comparator_x_south
execute as @e[tag=!storehouse_west,tag=!storehouse_east,tag=scm_storehouse] at @s if block ~-1 ~1 ~ comparator[facing=east,mode=compare] run function scm:machine/common/storehouse/comparator_y_east
execute as @e[tag=!storehouse_west,tag=!storehouse_east,tag=scm_storehouse] at @s if block ~1 ~1 ~ comparator[facing=west,mode=compare] run function scm:machine/common/storehouse/comparator_y_west
